# HAM :
# will add a new portlet to the page
# expects type
# will perform stuff to add a portlet depending on the type

set type [ns_queryget type]
set user_id [mashup::getuserid]
set reference [ns_queryget reference]
set error 0

# ns_log Notice "HAM : $type : $id : $user_id"

set mashup_url [mashup::get_url]

switch $type {
	"newsfeed" {		
		# newsfeed
		# set id [ns_queryget id]
		set id $reference
		set mashup_id [mashup::newportlet -user_id $user_id \
					-type $type \
					-title [db_string "source_title" "select title from na_sources where source_id=:id"] \
					-content_id [mashup::newsfeed::new -user_id $user_id -source_id $id]]
	}
	"myfeed" {
		set url $reference
		# fetch this user's aggregator
		set aggregator_id [mashup::newsfeed::userinit -user_id $user_id]
		# create the rss feed
		set source_array [news_aggregator::source::new -feed_url $reference -aggregator_id $aggregator_id -user_id [ad_conn user_id] -array]
		if { $source_array == 0 } { 
			set error 1 
		} else {
			# get feed id
			array set source $source_array
			set mashup_id [mashup::newportlet -user_id $user_id \
					-type $type \
					-title $source(title) \
					-content_id [mashup::newsfeed::new -user_id $user_id -source_id $source(source_id)]]			
		}
	}
	"tagcloud" {
		# tagcloud
		# set cloud_name [ns_queryget "cloud_name"]
		set cloud_name $reference
		set mashup_id [mashup::newportlet -user_id $user_id \
					-type $type \
					-title $cloud_name \
					-content_id [mashup::tagcloud::new -user_id $user_id -cloud_name $cloud_name]]
	}
	"weather" {
		# weather
		# set yw_code [ns_queryget "yw_code"]
		set yw_code $reference
		set mashup_id [mashup::newportlet -user_id $user_id \
					-type $type \
					-title "Weather" \
					-content_id [mashup::weather::new -user_id $user_id -yw_code $yw_code]]
	}
	"geoip" {
		# weather
		set ip [ns_conn peeraddr]
		set mashup_id [mashup::newportlet -user_id $user_id \
					-type $type \
					-title "Your Location" \
					-content_id [mashup::geoip::recordvisit -ip $ip -user_id $user_id]]
	}
	"xocontent" {
		# xowiki content
		# set item_id [ns_queryget "item_id"]
		set item_id $reference

		# query xowiki for the title of the item_id
		set xotitle [db_string "getxotitle" "select title from cr_revisions where revision_id = (select live_revision from cr_items where item_id=:item_id)"]
		regsub "en:" $xotitle "" xotitle
		set mashup_id [mashup::newportlet -user_id $user_id \
					-type $type \
					-title $xotitle \
					-content_id $item_id]
	}
	"googlead" {
		# google ads
		set ad_id [db_string "getad" "select id from googlead limit 1"]
		set title "Google Ads"
		set mashup_id [mashup::newportlet -user_id $user_id \
					-type $type \
					-title $title \
					-content_id $ad_id]
	}
}